/* pointer.h - concise macros for pointer checking and casting */
/* PNN(p) 		- test that p is not NULL, return p */
/* PNNC(p, t) 	- test that p is not NULL, return p cast to type t */
#ifndef POINTER_H
#define POINTER_H
#ifndef NDEBUG
#define PNN(p)			((p) != NULL ? (p) : PNN_BAD(p))
#define PNNC(p, t)		((p) != NULL ? (t)(p) : (t)PNN_BAD(p))
#define PNN_BAD(p)		(fprintf(stderr, "NULL\n"), p)
#else
#define PNN(p)			(p)
#define PNNC(p,t)		((t)(p))
#endif
#endif
